#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <vector>

const char *list[]={
	"program","var","array","of","integer","real","function","procedure","begin",
	"end","if","then","else","while","do","or","div","mod","and","not","for","to",
	"write","writeln","read","readln","string","text","return","byte","boolean",
	"assign","reset","close","repeat","until","case","length","delete","set","in",
	"char",
	"randomize","random",
	":=","<>",">=","<=","..",0
};

bool isDigit(char sym) { return sym>='0' && sym<='9';}
bool isSymbol(char sym) { return sym>='a' && sym<='z' || sym>='A' && sym<='Z';}
bool isSpace(char sym) { return sym==' ' || sym=='\n' || sym=='\t';}

char buffer[300];
bool isFunc=false;	//    

std::vector<char*>table;	//     

bool look_atom(FILE *in,FILE *out)
{
	const char c2[]=":<>.";
	int index=0;
	int mode=0;	// 0:undef  2:digit 1:id  3:special 4:string
	int sym;
l1:
	do{ sym=getc(in); if(sym=='\n') putc('\n',out); if(sym==EOF) return true;} while(isSpace(sym));
	if(sym=='{') {do{ sym=getc(in); if(sym==EOF) return true;} while(sym!='}'); goto l1;}
	buffer[index++]=sym; buffer[index]=0;
	if(isSymbol(sym)) mode=1; else
	if(isDigit(sym)) mode=2; else
    if(strchr(c2,sym)) mode=3; else 
	if(sym=='\'') mode=4; else
	goto l2;
        for(;;) {
		sym=getc(in); if(sym==EOF) break;
		switch(mode) {
		case 1: if(!isSymbol(sym) && !isDigit(sym) && sym!='_') mode=0; break;
		case 2: if(sym==':') { fprintf(out,"LABEL"); return false;}		
			if(!isDigit(sym)) mode=0; break;
		case 3: if(index==2) mode=0; else if(sym!='=' && !(sym=='.' || buffer[0]=='.') && !(sym=='>' && (buffer[0]==':' || buffer[0]=='<'))) mode=0; break;
		case 4: if(index>1 && buffer[index-1]=='\'') mode=0;
		}
		if(mode) buffer[index++]=sym,buffer[index]=0; else {ungetc(sym,in); break;}
	}
l2:
	printf("tok: [%s]\n",buffer);
	if(buffer[0]>='0' && buffer[0]<='9') {fprintf(out," NUM"); return false;}
	if(buffer[0]=='\'') {fprintf(out," STR"); return false;}
	strlwr(buffer);
	if(isFunc) table.push_back(strdup(buffer)); isFunc=false; 
	if(buffer[0]<'a' || buffer[0]>'z') {fprintf(out," %s",buffer); return false;}
	for(int n=0; list[n]; n++) {if(!strcmp(buffer,list[n])) { fprintf(out," %s",buffer); 
		if(!strcmp(buffer,"function") || !strcmp(buffer,"procedure")) isFunc=true;	return false;}}
	for(std::vector<char*>::iterator ptr=table.begin(); ptr!=table.end(); ptr++) 
		if(!strcmp((*ptr),buffer)) { fprintf(out," PID"); return false;}
	fprintf(out," ID");
	return false;
}






void main()
{
	FILE *in=fopen("1.pas","rt");
	FILE *out=fopen("x.test","wt");
	while(!look_atom(in,out));
	fprintf(out,"\n.\n");
	fclose(in); fclose(out);
}




